<?php

namespace Drupal\formfactorykits\Kits\Field\Date;

use Drupal\formfactorykits\Kits\FormFactoryKit;
use Drupal\formfactorykits\Kits\Traits\DescriptionTrait;
use Drupal\formfactorykits\Kits\Traits\TitleTrait;
use Drupal\formfactorykits\Kits\Traits\ValueTrait;

class DateTimeKit extends FormFactoryKit {
    use DescriptionTrait;
    use TitleTrait;
    use ValueTrait;

    public const DATE_INCREMENT_KEY = 'date_increment';
    public const DATE_TIMEZONE_KEY = 'date_timezone';
    public static ?string $id = 'datetime';
    public static ?string $type = 'datetime';

    public function setIncrement(string $increment): static
    {
        return $this->set(self::DATE_INCREMENT_KEY, $increment);
    }

    public function setTimeZone(\DateTimeZone $timezone): static
    {
        return $this->set(self::DATE_TIMEZONE_KEY, $timezone->getName());
    }
}
